#!/usr/bin/wish -f
# A TCL script to make various plots via gnuplot for the split2 program.

proc nokey {} {
    exec <@stdin >@stdout echo {set nokey};
}

proc plot1vs2varlines {file c1 c2 lim mn mx} {
    nokey
    if {$lim == 0} {
	set strng "plot 0, \"3bump.tics\" with lines, \"$file\" using $c1:$c2 with lines"
    } else {
      set strng "plot \[\] \[$mn:$mx\] 0, \"3bump.tics\" with lines, \"$file\" using $c1:$c2 with lines"
    }
    exec <@stdin >@stdout echo $strng
}

proc calculate {kf kd x0 xp0 amp bc1 bc2 bc3 nt xoff hint b1f b2f b3f} {
    set strng "set title \"kf=$kf, kd=$kd, x0=$x0, xp0=$xp0, amp=$amp, bc1=$bc1, bc2=$bc2, bc3=$bc3, x(q2)_off=$xoff"
    exec <@stdin >@stdout echo $strng
    set strng "kf=$kf;\nkd=$kd;\nx0=$x0;\nxp0=$xp0;\namp=$amp;\nbc1=$bc1;\nbc2=$bc2;\nbc3=$bc3;\nnturns=$nt;\nxoff=$xoff;\nhint=$hint;\nb1fto=$b1f;\nb2fto=$b2f;\nb3fto=$b3f;\n"
    set ff [open "3bump.params" w]
    puts $ff $strng
    close $ff
    set strng "!cat 3bump.params 3bump.oct|octave"
    exec <@stdin >@stdout echo $strng
}
#---------------------------------------
set kf 0.3
set kd -0.3
set x0 0.02
set xp0 0.0003
set amp 1
set bc1 0
set bc2 0
set bc3 0
set nturns 2
set xoff 0
#set b3_lim_min 0
#set b1_lim_min 0.3
#set b1_lim_max 0.4
#set b1lim 1
#---------------------------------------
frame .b3
pack .b3 -fill x

checkbutton .b3.lim -text limits -variable b3lim -relief flat

entry .b3.lim_min -width 10 -relief sunken -bd 2 -textvariable b3_lim_min
label .b3.to -text "to"
entry .b3.lim_max -width 10 -relief sunken -bd 2 -textvariable b3_lim_max

button .b3.plot -text "x vs s" -command {upvar 0 b3lim lim; \
	upvar 0 b3_lim_min mn;\
	upvar 0 b3_lim_max mx;\
	set strng "set xlabel \"s \[m\]\"\nset ylabel \"x \[m\]\"\n";\
	exec <@stdin >@stdout echo $strng;\
	plot1vs2varlines 3bump.dat 1 3 $lim $mn $mx}

pack .b3.plot .b3.lim .b3.lim_min .b3.to .b3.lim_max -side left -fill x
#---------------------------------------
frame .b4
pack .b4 -fill x

checkbutton .b4.lim -text limits -variable b4lim -relief flat

entry .b4.lim_min -width 10 -relief sunken -bd 2 -textvariable b4_lim_min
label .b4.to -text "to"
entry .b4.lim_max -width 10 -relief sunken -bd 2 -textvariable b4_lim_max

button .b4.plot -text "y vs s" -command {upvar 0 b4lim lim; \
	upvar 0 b4_lim_min mn;\
	upvar 0 b4_lim_max mx;\
	set strng "set xlabel \"s \[m\]\"\nset ylabel \"y \[m\]\"\n";\
	exec <@stdin >@stdout echo $strng;\
	plot1vs2varlines 3bump.dat 1 5 $lim $mn $mx}

#pack .b4.plot .b4.lim .b4.lim_min .b4.to .b4.lim_max -side left -fill x
#---------------------------------------
frame .b1
pack .b1 -fill x

checkbutton .b1.lim -text limits -variable b1lim -relief flat

entry .b1.lim_min -width 10 -relief sunken -bd 2 -textvariable b1_lim_min
label .b1.to -text "to"
entry .b1.lim_max -width 10 -relief sunken -bd 2 -textvariable b1_lim_max

button .b1.plot -text "3d" -command {upvar 0 b1lim lim; \
	upvar 0 b1_lim_min mn;\
	upvar 0 b1_lim_max mx;\
	set strng "set xlabel \"s \[m\]\"\nset ylabel \"\"\n";\
	exec <@stdin >@stdout echo $strng;\
	splot 3bump.dat 1 3 5 $lim $mn $mx}

#pack .b1.plot .b1.lim .b1.lim_min .b1.to .b1.lim_max -side left -fill x

#---------------------------------------
frame .calc
pack .calc -fill x
button .calc.doit -text "calculate" -command { upvar 0 Q0 q0
    upvar 0 kf kff
    upvar 0 kd kdd
    upvar 0 x0 x00
    upvar 0 xp0 xp00
    upvar 0 amp amp0
    upvar 0 bc1 bc10
    upvar 0 bc2 bc20
    upvar 0 bc3 bc30
    upvar 0 nturns nturns0
    upvar 0 xoff xoff0
    upvar 0 hint hint0
    upvar 0 bc1fto bc1f
    upvar 0 bc2fto bc2f
    upvar 0 bc3fto bc3f
calculate $kff $kdd $x00 $xp00 $amp0 $bc10 $bc20 $bc30 $nturns0 $xoff0 $hint0 $bc1f $bc2f $bc3f
}

pack .calc.doit -fill x
#---------------------------------------
frame .kf
pack .kf -fill x
label .kf.name -text "kf" -width 10
entry .kf.val -width 10 -relief sunken -bd 2 -textvariable kf

pack .kf.name .kf.val -side left -fill x
#---------------------------------------
frame .kd
pack .kd -fill x
label .kd.name -text "kd" -width 10
entry .kd.val -width 10 -relief sunken -bd 2 -textvariable kd

pack .kd.name .kd.val -side left -fill x
#---------------------------------------
frame .nturns
pack .nturns -fill x
label .nturns.name -text "nturns" -width 10
entry .nturns.val -width 10 -relief sunken -bd 2 -textvariable nturns

pack .nturns.name .nturns.val -side left -fill x
#---------------------------------------
frame .x0
pack .x0 -fill x
label .x0.name -text "x0" -width 10
entry .x0.val -width 10 -relief sunken -bd 2 -textvariable x0

pack .x0.name .x0.val -side left -fill x
#---------------------------------------
frame .xp0
pack .xp0 -fill x
label .xp0.name -text "xp0" -width 10
entry .xp0.val -width 10 -relief sunken -bd 2 -textvariable xp0

pack .xp0.name .xp0.val -side left -fill x
#---------------------------------------
frame .amp
pack .amp -fill x
label .amp.name -text "amplitude" -width 10
entry .amp.val -width 10 -relief sunken -bd 2 -textvariable amp
checkbutton .amp.hint -text answer -variable hint -relief flat

pack .amp.name .amp.val .amp.hint -side left -fill x
#---------------------------------------
frame .bc1
pack .bc1 -fill x
label .bc1.name -text "coef1" -width 10
entry .bc1.val -width 10 -relief sunken -bd 2 -textvariable bc1
checkbutton .bc1.fto -text "1st turn only" -variable bc1fto -relief flat

pack .bc1.name .bc1.val .bc1.fto -side left -fill x
#---------------------------------------
frame .bc2
pack .bc2 -fill x
label .bc2.name -text "coef2" -width 10
entry .bc2.val -width 10 -relief sunken -bd 2 -textvariable bc2
checkbutton .bc2.fto -text "1st turn only" -variable bc2fto -relief flat

pack .bc2.name .bc2.val .bc2.fto -side left -fill x
#---------------------------------------
frame .bc3
pack .bc3 -fill x
label .bc3.name -text "coef3" -width 10
entry .bc3.val -width 10 -relief sunken -bd 2 -textvariable bc3
checkbutton .bc3.fto -text "1st turn only" -variable bc3fto -relief flat

pack .bc3.name .bc3.val .bc3.fto -side left -fill x
#---------------------------------------
frame .xoffset
pack .xoffset -fill x
label .xoffset.name -text "2nd quad offset"
entry .xoffset.val -width 10 -relief sunken -bd 2 -textvariable xoff

pack .xoffset.name .xoffset.val -side left -fill x

#---------------------------------------
button .ps -text "PostScript of last plot" -command \
        {exec <@stdin >@stdout echo {set term postscript eps color "Times-Roman" 20};\
	exec <@stdin >@stdout echo {set output "quack.eps"};\
	exec <@stdin >@stdout echo {replot};\
	exec <@stdin >@stdout echo {set term x11}}
pack .ps -fill x
#---------------------------------------
button .quit -text "quit" -command exit
pack .quit -fill x

.b1.plot configure -bg Red4 -fg yellow
.b3.plot configure -bg SeaGreen -fg yellow
#.b4.plot configure -bg SeaGreen -fg yellow
.calc.doit configure -bg Gold -fg Red4
.ps configure -bg Blue -fg cyan
.quit configure -bg Red4 -fg yellow


