#!/usr/bin/wish -f
# A TCL script to make various plots via gnuplot for the split2 program.

proc plinit {} {
    exec <@stdin >@stdout echo {set nokey};
#    exec <@stdin >@stdout echo {set parametric};
}

proc plot1var {file c lim mn mx} {
    plinit
    if {$lim == 0} {
	set strng "plot \"$file\" using 0:$c with lines"
    } else {
	set strng "plot \[ \] \[$mn:$mx\] \"$file\" using 0:$c with lines"
    }
    exec <@stdin >@stdout echo $strng
}

proc plot2var {file c1 c2 lim mn mx} {
    plinit
    if {$lim == 0} {
	set strng "plot \"$file\" using 0:$c1, \"$file\" using 0:$c2"
    } else {
	set strng "plot \[\] \[$mn:$mx\] \"$file\" using 0:$c1, \"$file\" using 0:$c2"
    }
    exec <@stdin >@stdout echo $strng
}

proc plot1vs2varlines {file c1 c2 lim mn mx} {
    plinit
    if {$lim == 0} {
	set strng "plot \"$file\" using $c1:$c2 with lines"
    } else {
	set strng "plot \[\] \[$mn:$mx\] \"$file\" using $c1:$c2 with lines"
    }
    exec <@stdin >@stdout echo $strng
}

proc plot1vs2var {file c1 c2 lim mn mx} {
    plinit
    if {$lim == 0} {
	set strng "plot \"$file\" using $c1:$c2"
    } else {
	set strng "plot \[\] \[$mn:$mx\] \"$file\" using $c1:$c2"
    }
    exec <@stdin >@stdout echo $strng
}

proc splot {file c1 c2 c3 lim mn mx} {
    plinit
    if {$lim == 0} {
	set strng "splot \"$file\" using $c1:$c2:$c3 with lines"
    } else {
      set strng "splot \[$mn:$mx\] \"$file\" using $c1:$c2:$c3 with lines"
    }
    exec <@stdin >@stdout echo $strng
}

proc calculate {kf kd x0 xp0 y0 yp0 z0 d0 nt xoff} {
    set strng "set title \"kf=$kf, kd=$kd, x0=$x0, xp0=$xp0, y0=$y0, yp0=$yp0, x(q2)_off=$xoff"
    exec <@stdin >@stdout echo $strng
    set strng "kf=$kf;\nkd=$kd;\nx0=$x0;\nxp0=$xp0;\ny0=$y0;\nyp0=$yp0;\nz0=$z0;\ndelta0=$d0;\nnturns=$nt;\nxoff=$xoff;\n"
    set ff [open "fodo2.params" w]
    puts $ff $strng
    close $ff
    set strng "!cat fodo2.params fodo2.oct|octave"
    exec <@stdin >@stdout echo $strng
}
#---------------------------------------
set kf 0.3
set kd -0.3
set x0 0.00
set xp0 0
set y0 0
set yp0 0.000
set z0 0
set delta0 0
set nturns 2
set xoff 0.001
#set b3_lim_min 0
#set b1_lim_min 0.3
#set b1_lim_max 0.4
#set b1lim 1
#---------------------------------------
frame .b3
pack .b3 -fill x

checkbutton .b3.lim -text limits -variable b3lim -relief flat

entry .b3.lim_min -width 10 -relief sunken -bd 2 -textvariable b3_lim_min
label .b3.to -text "to"
entry .b3.lim_max -width 10 -relief sunken -bd 2 -textvariable b3_lim_max

button .b3.plot -text "x vs s" -command {upvar 0 b3lim lim; \
	upvar 0 b3_lim_min mn;\
	upvar 0 b3_lim_max mx;\
	set strng "set xlabel \"s \[m\]\"\nset ylabel \"x \[m\]\"\n";\
	exec <@stdin >@stdout echo $strng;\
	plot1vs2varlines fodo2.dat 1 3 $lim $mn $mx}

pack .b3.plot .b3.lim .b3.lim_min .b3.to .b3.lim_max -side left -fill x
#---------------------------------------
frame .b4
pack .b4 -fill x

checkbutton .b4.lim -text limits -variable b4lim -relief flat

entry .b4.lim_min -width 10 -relief sunken -bd 2 -textvariable b4_lim_min
label .b4.to -text "to"
entry .b4.lim_max -width 10 -relief sunken -bd 2 -textvariable b4_lim_max

button .b4.plot -text "y vs s" -command {upvar 0 b4lim lim; \
	upvar 0 b4_lim_min mn;\
	upvar 0 b4_lim_max mx;\
	set strng "set xlabel \"s \[m\]\"\nset ylabel \"y \[m\]\"\n";\
	exec <@stdin >@stdout echo $strng;\
	plot1vs2varlines fodo2.dat 1 5 $lim $mn $mx}

pack .b4.plot .b4.lim .b4.lim_min .b4.to .b4.lim_max -side left -fill x
#---------------------------------------
frame .b1
pack .b1 -fill x

checkbutton .b1.lim -text limits -variable b1lim -relief flat

entry .b1.lim_min -width 10 -relief sunken -bd 2 -textvariable b1_lim_min
label .b1.to -text "to"
entry .b1.lim_max -width 10 -relief sunken -bd 2 -textvariable b1_lim_max

button .b1.plot -text "3d" -command {upvar 0 b1lim lim; \
	upvar 0 b1_lim_min mn;\
	upvar 0 b1_lim_max mx;\
	set strng "set xlabel \"s \[m\]\"\nset ylabel \"\"\n";\
	exec <@stdin >@stdout echo $strng;\
	splot fodo2.dat 1 3 5 $lim $mn $mx}

#pack .b1.plot .b1.lim .b1.lim_min .b1.to .b1.lim_max -side left -fill x

#---------------------------------------
frame .calc
pack .calc -fill x
button .calc.doit -text "calculate" -command { upvar 0 Q0 q0
    upvar 0 kf kff
    upvar 0 kd kdd
    upvar 0 x0 x00
    upvar 0 xp0 xp00
    upvar 0 y0 y00
    upvar 0 yp0 yp00
    upvar 0 z0 z00
    upvar 0 delta0 delta00
    upvar 0 nturns nturns0
    upvar 0 xoff xoff0
calculate $kff $kdd $x00 $xp00 $y00 $yp00 $z00 $delta00 $nturns0 $xoff0
}

pack .calc.doit -fill x
#---------------------------------------
frame .kf
pack .kf -fill x
label .kf.name -text "kf" -width 10
entry .kf.val -width 10 -relief sunken -bd 2 -textvariable kf

pack .kf.name .kf.val -side left -fill x
#---------------------------------------
frame .kd
pack .kd -fill x
label .kd.name -text "kd" -width 10
entry .kd.val -width 10 -relief sunken -bd 2 -textvariable kd

pack .kd.name .kd.val -side left -fill x
#---------------------------------------
frame .nturns
pack .nturns -fill x
label .nturns.name -text "nturns" -width 10
entry .nturns.val -width 10 -relief sunken -bd 2 -textvariable nturns

pack .nturns.name .nturns.val -side left -fill x
#---------------------------------------
frame .x0
pack .x0 -fill x
label .x0.name -text "x0" -width 10
entry .x0.val -width 10 -relief sunken -bd 2 -textvariable x0

pack .x0.name .x0.val -side left -fill x
#---------------------------------------
frame .xp0
pack .xp0 -fill x
label .xp0.name -text "xp0" -width 10
entry .xp0.val -width 10 -relief sunken -bd 2 -textvariable xp0

pack .xp0.name .xp0.val -side left -fill x
#---------------------------------------
frame .y0
pack .y0 -fill x
label .y0.name -text "y0" -width 10
entry .y0.val -width 10 -relief sunken -bd 2 -textvariable y0

pack .y0.name .y0.val -side left -fill x
#---------------------------------------
frame .yp0
pack .yp0 -fill x
label .yp0.name -text "yp0" -width 10
entry .yp0.val -width 10 -relief sunken -bd 2 -textvariable yp0

pack .yp0.name .yp0.val -side left -fill x
#---------------------------------------
frame .z0
pack .z0 -fill x
label .z0.name -text "z0" -width 10
entry .z0.val -width 10 -relief sunken -bd 2 -textvariable z0

#pack .z0.name .z0.val -side left -fill x
#---------------------------------------
frame .delta0
pack .delta0 -fill x
label .delta0.name -text "delta0" -width 10
entry .delta0.val -width 10 -relief sunken -bd 2 -textvariable delta0

#pack .delta0.name .delta0.val -side left -fill x
#---------------------------------------
frame .xoffset
pack .xoffset -fill x
label .xoffset.name -text "2nd quad offset"
entry .xoffset.val -width 10 -relief sunken -bd 2 -textvariable xoff

pack .xoffset.name .xoffset.val -side left -fill x

#---------------------------------------
button .ps -text "PostScript of last plot" -command \
        {exec <@stdin >@stdout echo {set term postscript eps color "Times-Roman" 20};\
	exec <@stdin >@stdout echo {set output "quack.eps"};\
	exec <@stdin >@stdout echo {replot};\
	exec <@stdin >@stdout echo {set term x11}}
pack .ps -fill x
#---------------------------------------
button .quit -text "quit" -command exit
pack .quit -fill x

.b1.plot configure -bg Red4 -fg yellow
.b3.plot configure -bg SeaGreen -fg yellow
.b4.plot configure -bg SeaGreen -fg yellow
.calc.doit configure -bg Gold -fg Red4
.ps configure -bg Blue -fg cyan
.quit configure -bg Red4 -fg yellow


